#pragma once

#include <wx/wx.h>
#include <vlc/vlc.h>
#include <fstream>
#include <iostream>
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>


class cFrame : public wxFrame {
    public:
        cFrame();
        ~cFrame();

        struct passwd *pw = getpwuid(getuid());
        std::string homedir = pw->pw_dir;

        // Window content declaration

        libvlc_media_player_t *mp;
        libvlc_media_t *sender;
     
        libvlc_instance_t * inst = libvlc_new (0, NULL);

        wxMenuBar *menuBar = new wxMenuBar;
        wxMenu *menuHelp = new wxMenu;

        wxTextCtrl *t_box = nullptr;
        wxStaticText *t_show = nullptr;

        wxListBox *l_sender = nullptr;

        wxButton *b_pp = nullptr;
        wxButton *b_add = nullptr;
        wxButton *s_sender = nullptr;
        wxButton *b_refresh = nullptr;

        wxStaticText *s_val = nullptr;
        wxSlider *s_volume = nullptr;

        std::ifstream readfile;
        std::ofstream writefile;

        std::string line;

        void refreshList();

        void refreshEvent(wxCommandEvent &evt);

        void eraseFileLine(std::string path, std::string eraseLine);

        void OnScroll(wxCommandEvent &evt);

        void playRadio(const char* url);

        void OnPP(wxCommandEvent &evt);

        void OnAbout(wxCommandEvent &evt);

        void OnExit(wxCommandEvent &evt);

        void OnAdd(wxCommandEvent &evt);

        void OnRemove(wxCommandEvent &evt);

        void OnSearch(wxCommandEvent &evt);

        wxDECLARE_EVENT_TABLE();

};